SystemOrganization addCategory: #'Magritte-Tools'!

ORCmdMethodRefactoring subclass: #ORCmdMAMoveDescriptionsToInstanceRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tools'!

!ORCmdMAMoveDescriptionsToInstanceRefactoring methodsFor: 'accessing' stamp: 'NickAger 1/13/2012 17:56'!
label
	^ 'Update Magritte description'! !

!ORCmdMAMoveDescriptionsToInstanceRefactoring methodsFor: 'accessing' stamp: 'NickAger 1/13/2012 18:07'!
longDescription
	^ 'Move Magritte description to instance side and add a pragma.'! !

!ORCmdMAMoveDescriptionsToInstanceRefactoring methodsFor: 'as yet unclassified' stamp: 'NickAger 1/13/2012 11:36'!
refactoring
	^ MAMoveDescriptionsToInstanceRefactoring
		model: self model
		swapMethod: self currentNode selector
		in: self currentNode theClass! !

ORSwapMethodRefactoring subclass: #MAMoveDescriptionsToInstanceRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tools'!

!MAMoveDescriptionsToInstanceRefactoring class methodsFor: 'as yet unclassified' stamp: 'NickAger 1/13/2012 10:42'!
performFor: aClass
	aClass class allSelectors select: #isDescriptionSelector thenDo: [ :each |
		| refactoring |
		refactoring := self model: nil swapMethod: each in: aClass class.
		refactoring execute ]! !

!MAMoveDescriptionsToInstanceRefactoring class methodsFor: 'as yet unclassified' stamp: 'NickAger 1/12/2012 22:21'!
performForAllClasses
	Object allSubclasses do: [ :aClass | 
		(aClass class allSelectors detect: #isDescriptionSelector ifNone: [ nil ]) notNil ifTrue: [
			self performFor: aClass ] ]! !

!MAMoveDescriptionsToInstanceRefactoring methodsFor: 'as yet unclassified' stamp: 'NickAger 1/13/2012 16:30'!
alreadyIncludesMagritteSelectors: parseTree
	^ parseTree pragmas detect: [ :each | MAPragmaBuilder magritteSelectors includes: selector ] ifNone: [ false ]! !

!MAMoveDescriptionsToInstanceRefactoring methodsFor: 'as yet unclassified' stamp: 'NickAger 1/13/2012 18:05'!
createPragma: parseTree
	((selector = #descriptionContainer) or: [ selector isDescriptionExtension: #descriptionContainer ]) ifTrue: [
		^ RBPragmaNode new arguments: #(); selector: MAPragmaBuilder containerPragma; yourself ].
	
	(selector isDescriptionDefinition) ifTrue: [
		^ RBPragmaNode new arguments: #(); selector: MAPragmaBuilder descriptionPragma; yourself ].
	
	((selector isDescriptionSelector) and: [ selector numArgs = 1 ]) ifTrue: [
		| descriptionDefinitionSelector |
		descriptionDefinitionSelector := class allSelectors detect: [ :each | 
			each isDescriptionDefinition and: [ each isDescriptionExtension: selector ] ] ifNone: [ nil ].
		descriptionDefinitionSelector notNil ifTrue: [
			^ RBPragmaNode new arguments: (Array with: descriptionDefinitionSelector); selector:  MAPragmaBuilder descriptionExtensionPragma; yourself ] ].
	^ nil
! !

!MAMoveDescriptionsToInstanceRefactoring methodsFor: 'preconditions' stamp: 'NickAger 1/13/2012 17:56'!
preconditions
	^ RBCondition withBlock: [ selector isDescriptionSelector ]! !

!MAMoveDescriptionsToInstanceRefactoring methodsFor: 'as yet unclassified' stamp: 'NickAger 1/13/2012 17:22'!
renameDescriptionSelector: parseTree
	| selectorWithoutParameter hasParameter newSelector |
	selectorWithoutParameter := (hasParameter := (selector numArgs = 1)) ifTrue: [ selector allButLast ] ifFalse: [ selector ].
	newSelector := ((selector copyFrom: ('description' size) + 1 to: (selector size)) withFirstCharacterDownshifted), 'Description'.
	parseTree selector: (hasParameter ifTrue: [ newSelector, ':' ] ifFalse: [ newSelector ])
	! !

!MAMoveDescriptionsToInstanceRefactoring methodsFor: 'transforming' stamp: 'NickAger 1/13/2012 18:14'!
transform
	| parseTree methodBody |

	parseTree := class parseTreeFor: selector.
	self renameDescriptionSelector: parseTree.
	
	(self alreadyIncludesMagritteSelectors: parseTree) ifFalse: [
		| pragma |
		pragma := self createPragma: parseTree.
		parseTree body addNodeFirst: pragma ].
		
	methodBody := class methodFor: selector.
	target compile: (parseTree formattedCode) classified: 'magritte-descriptions'.
	class removeMethod: selector! !
